/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 2.1.0, Date: 20-Apr-2010.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "simpleArray.h"
#include "rtxsrc/rtxDiag.h"
#include "rtxsrc/rtxMemory.h"
#include "rtxsrc/rtxPrint.h"
#include "rtxsrc/rtxStreamFile.h"

int main (int argc, char** argv)
{
   SimpleArray  myArray;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  filename = "message.json";
   OSRTDiagTraceLevel traceLevel = OSRTDiagError;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!OSCRTLSTRCMP (argv[i], "-o")) filename = argv[++i];
         else if (!OSCRTLSTRCMP (argv[i], "-v")) traceLevel = OSRTDiagInfo;
         else if (!OSCRTLSTRCMP (argv[i], "-vv")) traceLevel = OSRTDiagDebug;
         else {
            printf ("usage: writer [options]\n");
            printf ("options:\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtxInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }
   if (traceLevel > OSRTDiagError) {
      rtxDiagSetTraceLevel (&ctxt, traceLevel);
   }

   /* Populate structure of generated type */

   Init_SimpleArray (&ctxt, &myArray);
   {
   OSXMLSTRING* str = rtxMemAllocType (&ctxt, OSXMLSTRING);
   str->value = (const OSUTF8CHAR*)"Fred Jones";
   str->cdata = FALSE;
   rtxDListAppend (&ctxt, &myArray.item, str);
   }
   {
   OSXMLSTRING* str = rtxMemAllocType (&ctxt, OSXMLSTRING);
   str->value = (const OSUTF8CHAR*)"John Smith";
   str->cdata = FALSE;
   rtxDListAppend (&ctxt, &myArray.item, str);
   }

   for (i = 0; i < 10; i++) {
      myArray.numbers.elem[i] = i + 1;
   }
   myArray.numbers.n = 10;

   /* Encode */

   stat = rtxStreamFileCreateWriter (&ctxt, filename);

   if (0 == stat)
      stat = JsonEnc_simpleArray (&ctxt, &myArray);

   rtxStreamClose (&ctxt);

   if (0 == stat) {
      printf ("encoded message:\n");
      rtxPrintFile (filename);
      printf ("\n");
   }
   else {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);

   return stat;
}
