/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 1.3.0, Date: 23-Jan-2008.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtxsrc/rtxSOAP.h"
#include "rtxsrc/rtxSocket.h"
#include "rtxmlsrc/rtXmlCppMsgBuf.h"
#include "rtxsrc/rtxStreamSocket.h"
#include "StockQuoteWSDL.h"

#define DEFAULT_URL "http://127.0.0.1:9123"

enum {
GETLASTTRADEPRICE,
Num_Operations
};

const char* operation_names[] = {
"GetLastTradePrice"
};

int getOperIdx (const char*);
int do_GetLastTradePrice (
GetLastTradePrice_Input*, GetLastTradePrice_Output*, GetLastTradePrice_Fault*
   );

int main (int argc, char** argv)
{
   OSSOAPCONN   soapConn;
   OSIPADDR     ipAddr = OSIPADDR_LOCAL;
   OSRTSOCKET   listenSocket;
   OSOCTET*     ptmpbuf = 0;
   OSXMLEncodeBuffer encodeBuffer;
   OSCTXT       ctxt;
   const char*  url = DEFAULT_URL;
   int          i, stat;
   OSBOOL       verbose = FALSE, trace = TRUE;
   int          operIndex = -1;

   // Process command line arguments

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-url")) {
            url = argv[++i];
         }
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: server [-v] [-url <url>] [-notrace]\n");
            printf ("   -v    verbose mode: print trace info\n");
            printf ("   -url  bind URL http://host:port\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   // Init context

   stat = rtXmlInitContext (&ctxt);

   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }

   if (verbose)
      rtxSetDiag (&ctxt, 1);

   rtxSoapInitConn (&soapConn, &ctxt, OSSOAPV1, url);

   // One-time socket package initialization (required for Windows only)

   stat = rtxSocketsInit();
   if (0 != stat) {
      printf ("Socket initialization failed.\n");
      rtxErrSetData (&ctxt, stat, __FILE__, __LINE__);
      rtxErrPrint (&ctxt);
      return stat;
   }

   // Create listener socket

   if ((stat = rtxSocketCreate (&listenSocket)) != 0) {
      rtxErrSetData (&ctxt, stat, __FILE__, __LINE__);
      rtxErrPrint (&ctxt);
      return stat;
   }

   // Bind the socket

   if ((stat = rtxSocketStrToAddr (soapConn.host, &ipAddr)) != 0) {
      rtxErrSetData (&ctxt, stat, __FILE__, __LINE__);
      rtxErrPrint (&ctxt);
      return stat;
   }
   if ((stat = rtxSocketBind (listenSocket, ipAddr, soapConn.port)) != 0) {
      rtxErrSetData (&ctxt, stat, __FILE__, __LINE__);
      rtxErrPrint (&ctxt);
      return stat;
   }

   // Wait for connection

   if ((stat = rtxSocketListen (listenSocket, 1)) != 0) {
      rtxErrSetData (&ctxt, stat, __FILE__, __LINE__);
      rtxErrPrint (&ctxt);
      return stat;
   }
   if (trace) printf ("Wait for connection...\n");
   stat = rtxSoapAcceptConn (listenSocket, &soapConn);
   if (0 != stat) {
      rtxErrSetData (&ctxt, stat, __FILE__, __LINE__);
      rtxErrPrint (&ctxt);
      return stat;
   }

   // Wait for request

   stat = rtxSoapRecvHttp (&soapConn);
   if (stat != 0) {
      rtxErrPrint (&ctxt);
      return stat;
   }
   if (trace) printf ("HTTP request received\n");

   // Read HTTP request into memory.  This is the XML message to be
   // decoded..

   stat = rtxSoapRecvHttpContent (&soapConn, &ptmpbuf);
   if (stat != 0) {
      rtxErrPrint (&ctxt);
      return stat;
   }

   OSXMLDecodeBuffer decodeBuffer (ptmpbuf, soapConn.contentLength);

   if (decodeBuffer.getStatus ()) {
      decodeBuffer.printErrorInfo();
      return decodeBuffer.getStatus ();
   }

   decodeBuffer.setDiag (verbose);

   operIndex = getOperIdx (soapConn.soapAction);

   // Decode
   switch (operIndex) {
      case GETLASTTRADEPRICE:
         {
           // Create control objects and decode
           GetLastTradePrice_Input* pInValue = 0;
           GetLastTradePrice_Input_CC pdu_in (decodeBuffer, pInValue);
           GetLastTradePrice_Output outValue;
           GetLastTradePrice_Fault faultValue;
           GetLastTradePrice_Output_CC pdu_out (encodeBuffer, outValue, faultValue);
           soapConn.soapAction = 0;

           stat = pdu_in.decode();

           if (0 == stat) {
              if (trace) {
                 printf ("Decoding of Request message was successful\n");
                 printf ("Decoded record:\n");
                 pdu_in.print ("GetLastTradePrice_Input");
                 printf ("\n");
              }
           }
           else if (trace) {
              printf ("Decoding failed\n");
              decodeBuffer.printErrorInfo();
              return stat;
           }

           // Prepare a response to the request

           stat = do_GetLastTradePrice (pInValue, &outValue, &faultValue);

           // Encode
           if (0 == stat || RTERR_SOAPFAULT == stat)
              stat = pdu_out.encode();

           if (0 == stat) {
              if (trace) {
                 printf ("Encoding of Response message was successful\n");
                 printf ("Encoded record:\n");
                 puts ((char*) encodeBuffer.getMsgPtr());
                 printf ("\n");
              }
           }
           else if (trace) {
              printf ("Encoding failed\n");
              encodeBuffer.printErrorInfo();
              return stat;
           }
           break;
         }

      default: printf ("Unknown operation\n");
               return -1;
               break;
   }

   // Send response
   soapConn.responseStatusCode = 200;
   stat = rtxSoapSendHttpResponse (&soapConn, encodeBuffer.getMsgPtr());
   if (stat != 0) {
      encodeBuffer.printErrorInfo();
      return stat;
   }
   if (trace) printf ("HTTP response sent\n");

   // Close connection

   rtxStreamClose (&ctxt);
   rtxFreeContext (&ctxt);

   return stat;
}

int getOperIdx (const char* soapActionStr)
{
   int          i;
   char*        pStr;
   const char*  delims = "#";
   char*        pToken;
   char*        pOperStr = 0;

   // parsing soapAction
   pStr = (char*) malloc (strlen(soapActionStr) + 1);
   strcpy (pStr, soapActionStr);

   pToken = strtok (pStr, delims);

   while (pToken != 0)
   {
   pOperStr = pToken;
   pToken = strtok (NULL, delims);
   }
   for (i = 0; i < Num_Operations; i++) {
      if (strcmp(pOperStr, operation_names[i]) == 0)
      {
         return i;
      }
   }

   return -1;
}

int do_GetLastTradePrice
(GetLastTradePrice_Input* pRequest, GetLastTradePrice_Output* pResponse,
   GetLastTradePrice_Fault* pFault)
{
   int stat = 0;

   pResponse->TradePrice.price = 34.50;

   return stat;
}

